(defun rowne (zb1 zb2)
	(and (zawiera zb1 zb2) (zawiera zb2 zb1))
)

(defun nalezy (a zb)
	(cond
		((or (atom a) (null a))
			(let (
				(tmpzb zb)
			)
				(dotimes (i (length tmpzb) t)
					(cond
						((equal (car tmpzb) a)
							(return-from nalezy t)
						)
					)
					(setq tmpzb (cdr tmpzb))
				)
				nil
			)			
		)
		(t
			(let (
				(tmpzb zb)
			)
				(dotimes (i (length tmpzb) t)
					(cond
						((and (listp (car tmpzb)) (rowne (car tmpzb) a))
							(return-from nalezy t)
						)
					)
					(setq tmpzb (cdr tmpzb))
				)
				nil
			)
		)
	)
)

(defun suma (zb1 zb2)
	(dotimes (i (length zb1) t)
		(cond
			((not (nalezy (car zb1) zb2))
				(setq zb2 (append zb2 (list (car zb1))))
			)
		)
		(setq zb1 (cdr zb1))
	)
	zb2
)

(defun iloczyn (zb1 zb2)
	(let (
		(tmpzb '())
	)
	(dotimes (i (length zb1) t)
		(cond
			((nalezy (car zb1) zb2)
				(setq tmpzb (append tmpzb (list (car zb1))))
			)
		)
		(setq zb1 (cdr zb1))
	)
	tmpzb
))

(defun zawiera (zb1 zb2)
	(dotimes (i (length zb1) t)
		(cond
			((not (nalezy (car zb1) zb2))
				(return-from zawiera nil)
			)
		)
		(setq zb1 (cdr zb1))
	)
)

(defun roznica (zb1 zb2)
	(let (
		(tmpzb '())
	)
	(dotimes (i (length zb1) t)
		(cond
			((not (nalezy (car zb1) zb2))
				(setq tmpzb (append tmpzb (list (car zb1))))
			)
		)
		(setq zb1 (cdr zb1))
	)
	tmpzb
))


(defun myfind (co gdzie)
	(let (
		(kopia gdzie)
	)
	(dotimes (i (length gdzie) t)
		(cond
			((equal (car gdzie) co)
				(return-from myfind kopia)
			)
		)
		(setq gdzie (cdr gdzie))
	)
	(setq gdzie kopia)
	(dotimes (i (length gdzie) t)
		(cond
			((and (listp (car gdzie)) (myfind co (car gdzie)))
				(return-from myfind (myfind co (car gdzie)))
			)
		)
		(setq gdzie (cdr gdzie))
	)
	nil
))
