;Jakub Madej B3

(defstruct osoba imie nazwisko plec wiek)
(setq baza nil)

(defun dodaj (imie nazwisko plec wiek)
	(setq baza (adjoin (make-osoba :imie imie :nazwisko nazwisko :plec plec :wiek wiek) baza))
)

(defun usun (&key (imie nil) (nazwisko nil) (plec nil) (wiek nil))
	(dolist (i baza t)
		(cond
			((and (xor (not imie) (equal (osoba-imie i) imie)) (xor (not nazwisko) (equal (osoba-nazwisko i) nazwisko)) (xor (not plec) (equal (osoba-plec i) plec)) (xor (not wiek) (equal (osoba-wiek i) wiek)))
				(setq baza (remove i baza))
			)
		)
	)
)

(defun modyfikuj (rekord &key (imie nil) (nazwisko nil) (plec nil) (wiek nil))
	(setq baza (remove rekord baza))
	(cond
		(imie
			(setf (osoba-imie rekord) imie)
		)
	)
	(cond
		(nazwisko
			(setf (osoba-imie rekord) nazwisko)
		)
	)
	(cond
		(plec
			(setf (osoba-plec rekord) plec)
		)
	)
	(cond
		(wiek
			(setf (osoba-wiek rekord) wiek)
		)
	)
	(setq baza (adjoin rekord baza))
)

(defun szukaj-or (&key (imie nil) (nazwisko nil) (plec nil) (wiek nil))
	(dolist (i baza t)
		(cond
			((or (and imie (equal (osoba-imie i) imie)) (and  nazwisko (equal (osoba-nazwisko i) nazwisko)) (and plec (equal (osoba-plec i) plec)) (and wiek (equal (osoba-wiek i) wiek)))
				(return-from szukaj-or i)
			)
		)
	)
)

(defun szukaj-and (&key (imie nil) (nazwisko nil) (plec nil) (wiek nil))
	(dolist (i baza t)
		(cond
			((and (xor (not imie) (equal (osoba-imie i) imie)) (xor (not nazwisko) (equal (osoba-nazwisko i) nazwisko)) (xor (not plec) (equal (osoba-plec i) plec)) (xor (not wiek) (equal (osoba-wiek i) wiek)))
				(return-from szukaj-and i)
			)
		)
	)
)

(defun zapisz (plik)
	(let (
		(str (open plik :direction :output))
	)
	(write baza :stream str)
	(close str)
))

(defun czytaj (plik)
	(let (
		(str (open plik))
	)
	(setq baza (read str))
	(close str)
))
