; Jakub Madej B3

(defun nie_lubia_sie (a b antagonizmy)
	(or (moze_zjesc a b antagonizmy) (moze_zjesc b a antagonizmy))
)

(defun moze_zjesc (a b antagonizmy)
	(dolist (i antagonizmy nil)
		(cond
			((and (equal (car i) a) (equal (cadr i) b))
				(return t)
			)
		)
	)
)

(defun ile_antagonizmow (brzeg zwierzatko antagonizmy)
	(let (
		(r 0)
	)
	(dolist (i brzeg r)
		(cond
			((nie_lubia_sie i zwierzatko antagonizmy)
				(setf r (+ r 1))
			)
		)
	)
))

(defun zjadanie (brzeg antagonizmy)
	(dolist (a brzeg nil)
		(dolist (b brzeg)
			(cond
				((moze_zjesc a b antagonizmy)
					(format t "~S zjada ~S!~%" a b)
					(return-from zjadanie t)
				)
			)
		)
	)
)

(defun przewiez_z_lewej (max brzegz brzegna antagonizmy)
	(let (
		(lodka nil)
		(kto nil)
		(newant 0)
		(maxant 0)
		(pierwszy t)
	)
	(dotimes (i max)
		(setf maxant 0)
		(setf pierwszy t)
		(setf kto nil)
		(dolist (x brzegz)
			(setf newant (- (ile_antagonizmow brzegz x antagonizmy) (ile_antagonizmow brzegna x antagonizmy)))
			(cond
				((or pierwszy (>= newant maxant))
					(setf pierwszy nil)
					(setf maxant newant)
					(setf kto x)
				)
			)
		)
		(cond
			(kto
				(setf lodka (append lodka (list kto)))
			)
		)
		(setf brzegz (remove kto brzegz))
	)
	(format t "~%Przewoze: ~S~%~%" lodka)
	(setf brzegna (append brzegna lodka))
	`(,brzegz ,brzegna)
))

(defun przewiez_z_prawej (max prawy_brzeg lewy_brzeg antagonizmy)
	(let (
		(lodka nil)
		(kto nil)
		(newant 0)
		(maxant 0)
	)
	(dotimes (i max)
		(setf maxant 0)
		(setf kto nil)
		(dolist (x prawy_brzeg)
			(setf newant (ile_antagonizmow prawy_brzeg x antagonizmy))
			(cond
				((> newant 0)
					(setf newant (+ newant (ile_antagonizmow lewy_brzeg x antagonizmy)))
					(cond
						((>= newant maxant)
							(setf maxant newant)
							(setf kto x)
						)
					)
				)
			)
		)
		(cond
			(kto
				(setf lodka (append lodka (list kto)))
			)
		)
		(setf prawy_brzeg (remove kto prawy_brzeg))
	)
	(format t "~%Przewoze: ~S~%~%" lodka)
	(cond
		((car lodka)
			(setf lewy_brzeg (append lewy_brzeg lodka))
		)
	)
	`(,prawy_brzeg ,lewy_brzeg)
))

(defun rozwiaz (zwierzeta antagonizmy &optional (pojemnosc 1))
	(let (
		(lewy_brzeg zwierzeta)
		(prawy_brzeg nil)
		(tmp nil)
	)
	(format t "Proba dla ~D miejsc w lodce~%--------------------------~%" pojemnosc)
	(format t "Lewy brzeg: ~S oraz przewoznik~%" lewy_brzeg)

	(loop
		(setf tmp (przewiez_z_lewej pojemnosc lewy_brzeg prawy_brzeg antagonizmy))
		(setf lewy_brzeg (car tmp))
		(setf prawy_brzeg (cadr tmp))
				
		(format t "Prawy brzeg: ~S oraz przewoznik~%" prawy_brzeg)
		
		(cond
			((zjadanie lewy_brzeg antagonizmy)
				(format t "Nie udalo sie, probuje dla wiekszej ilosci miejsc~%")
				(rozwiaz zwierzeta antagonizmy (+ pojemnosc 1))
				(return)
			)
		)

		(cond
			((not lewy_brzeg)
				(return)
			)
		)
	
		(setf tmp (przewiez_z_prawej pojemnosc prawy_brzeg lewy_brzeg antagonizmy))
		(setf prawy_brzeg (car tmp))
		(setf lewy_brzeg (cadr tmp))
				
		(format t "Lewy brzeg: ~S oraz przewoznik~%" lewy_brzeg)

		(cond
			((zjadanie prawy_brzeg antagonizmy)
				(format t "Nie udalo sie, probuje dla wiekszej ilosci miejsc~%")
				(rozwiaz zwierzeta antagonizmy (+ pojemnosc 1))
				(return)
			)
		)
	)

	(format t "~%Udalo sie~%")
))
