(defun sort-skos (tab2d)
	(let* ((wym (array-dimension tab2d 1))
		(lista '())
		(x 0)
		(y (- wym 1))
	)
	(dotimes (i wym t)
		(dotimes (j wym t)
			(setq lista (append lista (list (aref tab2d i j))))
		)
	)
	(setq lista (sort lista #'<))
	(dotimes (i (* wym wym) t)
		(setf (aref tab2d y x) (car lista))
		(setq lista (cdr lista))
		(setq x (+ x 1))
		(setq y (+ y 1))
		(cond ((and (= y wym) (= x wym)) (setq y 0) (setq x 1))
		      ((= y wym) (setq y (- wym (+ x 1))) (setq x 0))
		      ((= x wym) (setq x (- wym (- y 1))) (setq y 0))
		)
	)
	tab2d
))

(defun printab (tab2d)
	(let* (
		(wym (array-dimension tab2d 1))
		(maxcyfr 0)
	)
	(dotimes (i wym t)
		(dotimes (j wym t)
			(cond
				((< maxcyfr (length (prin1-to-string (aref tab2d i j))))
					(setq maxcyfr (length (prin1-to-string (aref tab2d i j))))
				)
			)
		)
	)
	(dotimes (i wym t)
		(dotimes (j wym t)
			(dotimes (k (- maxcyfr (length (prin1-to-string (aref tab2d i j)))) t)
				(princ " ")
			)
			(prin1 (aref tab2d i j))
			(princ " ")
		)
		(terpri)
	)
))
