;Jakub Madej B3

(SETQ TREE '((HEADER (DESCRIPTION (BRIEF Informatyka4)
                                  (FULL Program studiow na czwartym semestrze kierunku informatyka ))
                     (CREATEDON 2 kwietnia 2004 r))
             (AUTHOR   (FIRSTNAME Jakub) (LASTNAME Madej) (EMAIL jadqba@student.uci.agh.edu.pl))
             (D (NAME Info3)
                 (PARP 1)
                 (PARQ 1)
                 (UPPER nil)
                 (LOWER D1 D2 D3))
             (D1 (NAME Mownit)
                 (PARP 0.45)
                 (PARQ nil)
                 (UPPER D)
                 (LOWER D11 D12 D13))
             (D2 (NAME Lisp)
                 (PARP 0.2)
                 (UPPER D)
                 (LOWER nil))
             (D3 (NAME Automaty)
                 (PARP 0.35)
                 (UPPER D)
                 (LOWER D31 D32))
            (D11 (NAME Interpolacja)
                 (PARP 0.3)
                 (PARQ nil)
                 (UPPER D1)
                 (LOWER D111 D112 D113))
            (D12 (NAME Aproksymacja)
                 (PARP 0.4)
                 (UPPER D1)
                 (LOWER D121 D122))
            (D13 (NAME Funkcje sklejane)
                 (PARP 0.3)
                 (UPPER D1)
                 (LOWER nil))
           (D111 (NAME Lagrangea)
                 (PARP 0.25)
                 (UPPER D11)
                 (LOWER nil))
           (D112 (NAME Czebyszewa)
                 (PARP 0.35)
                 (UPPER D11))
           (D113 (NAME Trygonometryczna)
                 (PARP 0.40)
                 (UPPER D11))
           (D121 (NAME Sredniokwadratowa)
                 (PARP 0.50)
                 (UPPER D12))
           (D122 (NAME Jednostajna)
                 (PARP 0.50)
                 (UPPER D12))
	   (D31  (NAME Skonczone)
		 (PARP 0.50)
		 (UPPER D3))
	   (D32  (NAME Ze stosem)
		 (PARP 0.50)
		 (UPPER D3)))
)

(defun autor ()
	(let (
		(author (assoc 'author tree))
	)
	(setq author (cdr author))
	(list (cadr (assoc 'firstname author)) (cadr (assoc 'lastname author)))
))

(defun root ()
	(dolist (i tree nil)
		(cond
			((and (not (equal (car i) 'HEADER)) (not (equal (car i) 'AUTHOR)) (null (cadr (assoc 'UPPER (cdr i)))))
				(return-from root (car i))
			)
		)
	)
)

(defun low (id)
	(remove nil (cdr (assoc 'LOWER (cdr (assoc id tree)))))
)

(defun up (id)
	(cadr (assoc 'UPPER (cdr (assoc id tree))))
)

(defun linki (d1 d2 &optional (zk t))
	(let (
		(lista nil)
	)
	(cond
		((equal d1 d2)
			(return-from linki (list d1))
		)
	)
	(dolist (i (low d1) t)
		(setq lista (append lista (linki i d2 nil)))
	)
	(cond
		((not (null lista))
			(return-from linki (append (list d1) lista))
		)
		((null zk)
			nil
		)
		(t
			(linki d2 d1 nil)
		)
	)
))

(defun linkp (d1 d2)
	(cond
		((= (length (linki d1 d2)) 2)
			t
		)
		(t
			nil
		)
	)
)

(defun idlist (&optional (r nil))
	(let (
		(lista nil)
	)
	(cond
		((null r)
			(idlist (root))
		)
		(t
			(dolist (i (low r) t)
				(setq lista (append lista (idlist i)))
			)
			(cond
				((not (null lista))
					(append (list r) (list lista))
				)
				(t
					(list r)
				)
			)
		)
	)
))

(defun sprawdzp (&optional (r nil))
	(let (
		(suma 0)
	)
	(cond
		((null r)
			(and (= (cadr (assoc 'PARP (cdr (assoc (root) tree)))) 1) (sprawdzp (root)))
		)
		(t
			(cond
				((not (null (low r)))
					(dolist (i (low r) t)
						(setq suma (+ suma (cadr (assoc 'PARP (cdr (assoc i tree))))))
						(cond
							((not (sprawdzp i))
								(return-from sprawdzp nil)
							)
						)
					)
					(cond
						((= suma 1)
							t
						)
						(t
							nil
						)
					)
				)
				(t
					t
				)
			)
		)
	)
))

(defun liczq (&optional (r nil) (q 0))
	(cond
		((null r)
			(liczq (root) 1)
		)
		(t
			(cond
				((null (assoc 'PARQ (cdr (assoc r tree))))
					(setf (cdr (assoc r tree)) (append (cdr (assoc r tree)) (list (list 'PARQ (* q (cadr (assoc 'PARP (cdr (assoc r tree)))))))))
				)
				(t
					(setf (cadr (assoc 'PARQ (cdr (assoc r tree)))) (* q (cadr (assoc 'PARP (cdr (assoc r tree))))))
				)
			)
			(dolist (i (low r) t)
				(liczq i (cadr (assoc 'PARQ (cdr (assoc r tree)))))
			)
		)
	)
)
