;Jakub Madej B3

(setq tab (make-array '(3 3) :initial-contents '((2 t 3) (6 1 8) (5 4 7))))

(defun przeksztalc (tab &optional (P 'P))
	(remprop P 'co)
	(let (
		(bigtab (make-array `(,(+ (array-dimension tab 0) 2) ,(+ (array-dimension tab 0) 2)) :initial-element nil))
	)
	(dotimes (i (array-dimension tab 0) t)
		(dotimes (j (array-dimension tab 0) t)
			(setf (aref bigtab (+ i 1) (+ j 1)) (aref tab i j))
		)
	)
	(dotimes (i (array-dimension tab 0) t)
		(dotimes (j (array-dimension tab 0) t)
			(let (
				(symbol (gensym))
			)
			(setf (get symbol 'wartosc) (aref bigtab (+ i 1) (+ j 1)))
			(setf (get symbol 'miejsce) (+ (* i 3) j 1))
			(SETF (GET P 'co) (ADJOIN symbol (GET P 'co)))
		))
	)
	(napraw P)
))

(defun wymiar ()
	(let (
		(max 0)
	)
	(dolist (i (get 'P 'co) t)
		(setq max (max max (get i 'miejsce)))
	)
	(sqrt max)
))

(defun drukuj (&optional (P 'P))
	(let (
		(tab (make-array `(,(wymiar) ,(wymiar))))
	)
	(dolist (i (get P 'co) t)
		(setf (aref tab  (truncate (- (get i 'miejsce) 1) (wymiar)) (- (get i 'miejsce) (* (truncate (- (get i 'miejsce) 1) (wymiar)) (wymiar)) 1)) (get i 'wartosc))
	)
	(printab tab)
))

(defun printab (tab2d)
	(let* (
		(wym (array-dimension tab2d 1))
		(maxcyfr 0)
	)
	(dotimes (i wym t)
		(dotimes (j wym t)
			(cond
				((< maxcyfr (length (prin1-to-string (aref tab2d i j))))
					(setq maxcyfr (length (prin1-to-string (aref tab2d i j))))
				)
			)
		)
	)
	(dotimes (i wym t)
		(dotimes (j wym t)
			(dotimes (k (- maxcyfr (length (prin1-to-string (aref tab2d i j)))) t)
				(princ " ")
			)
			(prin1 (aref tab2d i j))
			(princ " ")
		)
		(terpri)
	)
))

(defun ruch (el &optional (P 'P))
	(let (
		(symbol (element el P))
	)
	(cond
		((equal t (get symbol 'prawo))
			(return-from ruch `(,el PRAWO))
		)
		((equal t (get symbol 'lewo))
			(return-from ruch `(,el LEWO))
		)
		((equal t (get symbol 'dol))
			(return-from ruch `(,el DOL))
		)
		((equal t (get symbol 'gora))
			(return-from ruch `(,el GORA))
		)
	)
	nil
))

(defun ruchy (&optional (P 'P))
	(let (
		(lista nil)
	)
	(dolist (i (get P 'co) t)
		(setq lista (adjoin (ruch (get i 'wartosc)) lista))
	)
	(remove nil lista)
))

(defun napraw (&optional (P 'P))
	(let (
		(tab (make-array `(,(wymiar) ,(wymiar))))
	)
	(dolist (i (get P 'co) t)
		(setf (aref tab  (truncate (- (get i 'miejsce) 1) (wymiar)) (- (get i 'miejsce) (* (truncate (- (get i 'miejsce) 1) (wymiar)) (wymiar)) 1)) (get i 'wartosc))
	)
	(let (
		(bigtab (make-array `(,(+ (array-dimension tab 0) 2) ,(+ (array-dimension tab 0) 2)) :initial-element nil))
	)
	(dotimes (i (array-dimension tab 0) t)
		(dotimes (j (array-dimension tab 0) t)
			(setf (aref bigtab (+ i 1) (+ j 1)) (aref tab i j))
		)
	)
	(dotimes (i (array-dimension tab 0) t)
		(dotimes (j (array-dimension tab 0) t)
			(let (
				(symbol (element (aref tab i j) P))
			)
			(setf (get symbol 'gora) (aref bigtab i (+ j 1)))
			(setf (get symbol 'dol) (aref bigtab (+ i 2) (+ j 1)))
			(setf (get symbol 'lewo) (aref bigtab (+ i 1) j))
			(setf (get symbol 'prawo) (aref bigtab (+ i 1) (+ j 2)))
		))
	)
)))

(defun rusz (w &optional (P 'P))
	(let (
		(tmp1 (element w P))
		(tmp2 (element t P))
	)
	(cond
		((ruch w P)
			(setf (get tmp1 'wartosc) t)
			(setf (get tmp2 'wartosc) w)
			(napraw P)
		)
	)
))

(defun element (w &optional (P 'P))
	(dolist (i (get P 'co) t)
		(cond
			((equal (get i 'wartosc) w)
				(return-from element i)
			)
		)
	)
)

(defun puzzle (tab)
	`(,(length (ruchy)) ,(ruchy))
)